#ifndef __ID_CA__
#define __ID_CA__

//===========================================================================

#define NUMMAPS         60
#ifdef USE_FLOORCEILINGTEX
    #define MAPPLANES       3
#else
    #define MAPPLANES       2
#endif

#define UNCACHEGRCHUNK(chunk) {if(grsegs[chunk]) {free(grsegs[chunk]); grsegs[chunk]=NULL;}}
#ifndef VIEASM
    #define UNCACHEAUDIOCHUNK(chunk) {if(audiosegs[chunk]) {free(audiosegs[chunk]); audiosegs[chunk]=NULL;}}
#endif

//===========================================================================

#define MAXTITLECHARS   16

typedef struct
{
    int32_t planestart[3];
    word    planelength[3];
    word    width,height;
    char    name[MAXTITLECHARS];
} maptype;

typedef struct
{
    word RLEWtag;
    int32_t headeroffsets[100];
} mapfiletype;

//===========================================================================

extern  int   mapon;

extern  word *mapsegs[MAPPLANES];
extern  maptype *mapheaderseg[NUMMAPS];
#ifndef VIEASM
extern  byte *audiosegs[NUMSNDCHUNKS];
#endif
extern  byte *grsegs[NUMCHUNKS];

extern  word  RLEWtag;

extern  char  extension[5];
extern  char  graphext[5];
#ifndef VIEASM
extern  char  audioext[5];
#endif

extern const char mheadname[];

//===========================================================================

boolean CA_LoadFile (const char *filename, memptr *ptr);
boolean CA_WriteFile (const char *filename, void *ptr, int32_t length);

int32_t CA_RLEWCompress (word *source, int32_t length, word *dest, word rlewtag);

void CA_RLEWexpand (word *source, word *dest, int32_t length, word rlewtag);

void CA_Startup (void);
void CA_Shutdown (void);

int32_t CA_CacheAudioChunk (int chunk);
void CA_LoadAllSounds (void);

void CA_CacheGrChunk (int chunk);
void CA_CacheMap (int mapnum);

void CA_CacheScreen (int chunk);

void CA_CannotOpen(const char *name);

#ifdef MAPNAME
void CA_PrintMapName(int which);
#endif

void CAL_CarmackExpand (byte *source, word *dest, int length);

int CAL_CarmackCompress (word *source, int length, word *dest);

#endif
