#include "lw_command.h"
using namespace lwlib;

Command::Command()
{
	lwlib_Zero(priv);
}

void Command::addToEdit(Edit *edit)
{
	edit->addItem_string("key", priv.key, sizeof(priv.key));
	edit->addItem_bool("go", &priv.go);
	edit->addItem_enum("event", 
		(int *)&priv.event, lwlib_Keys_Event_Str, NULL,
		lwlib_Keys_Event_StrCount);
	edit->addItem_bool("mouseEnabled", &priv.mouseEnabled);
	edit->addItem_enum("mouseButton", 
		(int *)&priv.mouseButton, Mouse_Button_Str, NULL,
		Mouse_Button_StrCount);
	edit->addItem_enum("mouseEvent", 
		(int *)&priv.mouseEvent, Mouse_Event_Str, NULL,
		Mouse_Event_StrCount);
}

bool Command::pending()
{
	bool go;

	go = priv.go;
	if (go)
	{
		priv.go = false;
	}

	return go;
}

void Command::processEvents(lwlib_Keys_t keys, Mouse_t mouse)
{
	if (lwlib_Keys_CheckEvent(keys, priv.key, priv.event))
	{
		priv.go = true;
	}

	if (priv.mouseEnabled)
	{
		if (mouse->checkButtonStatus(priv.mouseButton,
			priv.mouseEvent))
		{
			priv.go = true;
		}
	}
}
