#ifndef LW_COMMAND_H
#define LW_COMMAND_H

#include "lw_edit.h"
#include "lw_keys.h"
#include "lw_mouse.h"
#include "vec.h"

namespace lwlib
{
	class Command
	{
		struct
		{
			lwlib_String_t key;
			bool go;
			lwlib_Keys_Event_t event;
			bool mouseEnabled;
			Mouse_Button::e mouseButton;
			Mouse_Event::e mouseEvent;
		} priv;

	public:
		Command();

		void addToEdit(Edit *edit);

		bool pending();

		void reset();

		void processEvents(lwlib_Keys_t keys, Mouse_t mouse);
	};

	typedef Command *CommandPtr_t;
	typedef vec_t(CommandPtr_t) CommandPtrVec_t;

}

#endif
