/*************************************************************************
** Wolf3D Legacy
** Copyright (C) 2012 by LinuxWolf - Team RayCAST
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**************************************************************************
** LinuxWolf Library for Wolf3D Legacy
*************************************************************************/

#ifndef LWLIB_RASTER_H
#define LWLIB_RASTER_H

#include "lw_misc.h"
#include "lw_color.h"
#include "fixedptc.h"

typedef struct lwlib_Raster_Screen_s
{
	lwlib_Color_Pix_t *vbuf;
	int pitch;
	fixedpt *zbuf;
} lwlib_Raster_Screen_t;

typedef struct lwlib_Raster_Viewport_s
{
	int x, y;
	int w, h;
} lwlib_Raster_Viewport_t;

typedef struct lwlib_Raster_Texture_s
{
	lwlib_Color_Pix_t *tex; // u major, v minor
	int nu, nv;
	int nuLog2, nvLog2;
} lwlib_Raster_Texture_t;

typedef struct lwlib_Raster_Vertex_s
{
	int x, y;
	float uiz, viz;
	float iz;
} lwlib_Raster_Vertex_t;

typedef struct lwlib_Raster_DrawPoly_s
{
	lwlib_Raster_Screen_t screen;
	lwlib_Raster_Viewport_t viewport;
	lwlib_Raster_Texture_t texture;
	lwlib_Byte_t *shadetable;
	lwlib_Raster_Vertex_t *vertexs;
	int numVertexs;
	lwlib_Color_Pix_t blendPix;
	bool affine;
	bool fast2D;
} lwlib_Raster_DrawPoly_t;

void lwlib_Raster_DrawPoly(const lwlib_Raster_DrawPoly_t *drawPoly);

#endif

