/*************************************************************************
** Wolf3D Legacy
** Copyright (C) 2012 by LinuxWolf - Team RayCAST
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**************************************************************************
** LinuxWolf Library for Wolf3D Legacy
*************************************************************************/

#ifndef LWLIB_RENDER_H
#define LWLIB_RENDER_H

#include "lw_vec.h"
#include "lw_misc.h"

typedef struct lwlib_Render_s
{
	void *user;
	void (*drawBox)(void *user, lwlib::Box3f box);
	void (*drawBoxFacing)(void *user, lwlib::Box3f box, int facing);
} lwlib_Render_t;

static inline lwlib_Render_t lwlib_Render(void *user)
{
	lwlib_Render_t render;
	lwlib_Zero(render);
	render.user = user;
	return render;
}

#endif
