/*************************************************************************
** Wolf3D Legacy
** Copyright (C) 2012 by LinuxWolf - Team RayCAST
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**************************************************************************
** LinuxWolf Library for Wolf3D Legacy
*************************************************************************/

#ifndef LWLIB_TIMER_H
#define LWLIB_TIMER_H

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#if !defined(_WIN32)
#include <stdint.h>
#endif

namespace lwlib
{
	class Timer
	{
		struct
		{
			uint32_t ms;
		} priv;

	public:
		Timer();

		bool isZero() const { return priv.ms == 0; }

		bool elapsed(uint32_t ms) const;

		double gapInSeconds(const Timer &a) const;

		void addDuration(double sec);

		double secondsElapsed() const;
	};

	extern Timer g_frameTimer;

	class TimerFps
	{
		struct
		{
			uint32_t frames;
			uint32_t oldTime;
			uint32_t newTime;
			uint32_t lastFpsTime;
			int fpsShow;
		} priv;
	
	public:
		TimerFps();

		void updateFrame();
	};
}

#endif
